package com.sa.ibiz.demo.demo.rest;

import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.sa.ibiz.demo.demo.domain.WFInstance;
import com.sa.ibiz.demo.demo.service.WFInstanceService;
import com.sa.ibiz.demo.demo.service.dto.WFInstanceSearchFilter;
import com.sa.ibiz.demo.ibizutil.errors.BadRequestAlertException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.validation.annotation.Validated;
import org.springframework.web.bind.annotation.*;
import java.math.BigInteger;
import java.util.List;

@RestController
@RequestMapping("/demo/wfinstance")
public class WFInstanceResource
{
	@Autowired
	private WFInstanceService service;


	@GetMapping(value = "/{id}")
	public ResponseEntity<WFInstance> get(@Validated @PathVariable String id){
		WFInstance data=new WFInstance();
		data.setWfinstanceid(id);;
		data=service.get(data);
		if(data==null)
			throw new BadRequestAlertException("工作流实例[get]操作发生错误","WFInstance",id.toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/remove")
	public ResponseEntity<WFInstance> remove(@Validated @RequestBody WFInstance data){
		boolean bRt=service.remove(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流实例[remove]操作发生错误","WFInstance",data.getWfinstanceid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/userCancel")
	public ResponseEntity<WFInstance> userCancel(@Validated @RequestBody WFInstance data){
		service.userCancel(data);
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/getDraft")
	public ResponseEntity<WFInstance> getDraft(@Validated @RequestBody WFInstance data){
		boolean bRt=service.getDraft(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流实例[getDraft]操作发生错误","WFInstance","");
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/update")
	public ResponseEntity<WFInstance> update(@Validated @RequestBody WFInstance data){
		boolean bRt=service.update(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流实例[update]操作发生错误","WFInstance",data.getWfinstanceid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/create")
	public ResponseEntity<WFInstance> create(@Validated @RequestBody WFInstance data){
		boolean bRt=service.create(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流实例[create]操作发生错误","WFInstance",data.getWfinstanceid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/checkKey")
	public ResponseEntity<WFInstance> checkKey(@Validated @RequestBody WFInstance data){
		boolean bRt=service.checkKey(data);
		if(!bRt)
			throw new BadRequestAlertException("工作流实例[checkKey]操作发生错误","WFInstance",data.getWfinstanceid().toString());
		return ResponseEntity.ok().body(data);
	}
	@PostMapping(value = "/restart")
	public ResponseEntity<WFInstance> restart(@Validated @RequestBody WFInstance data){
		service.restart(data);
		return ResponseEntity.ok().body(data);
	}
    @PostMapping(value="/searchdefault")
	public ResponseEntity<Page<WFInstance>> searchDefaultPage(@Validated @RequestBody WFInstanceSearchFilter filter){
		Page<WFInstance> searchResult = service.searchDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}

	@PostMapping(value="/listdefault")
	public ResponseEntity<List<WFInstance>> listDefault(@Validated @RequestBody WFInstanceSearchFilter filter){
		List<WFInstance> searchResult = service.listDefault(filter);
		return ResponseEntity.ok().body(searchResult);
	}
}
